#include <iostream>
#include <conio.h>
#include <vector>
#include <stdlib.h>
using namespace std;

int main()
{
    const size_t MAX_ELEMENT = 76;
    size_t number_count;
    cerr << "Enter number count: ";
    cin >> number_count;

    vector<double> numbers(number_count);
    cerr << "Enter numbers: " << endl;
    for (size_t i=0; i < number_count; i++)
    {
        cin >> numbers[i];
    }

    size_t bin_count;
    cerr << "Enter bin count: ";
    cin >> bin_count;

    double min = numbers[0];
    double max = numbers[0];
    for(size_t i=0; i < number_count; i++){
        if (numbers[i] < min)
        {
            min = numbers[i];
        }
        else if (numbers[i] > max)
        {
            max = numbers[i];
        }
    }

    vector<size_t> bins(bin_count);
    double bin_size = (max - min) / bin_count;

    for (size_t i = 0; i < number_count; i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lower_Bound = min + j * bin_size;
            auto upper_Bound = min + (j + 1) * bin_size;
            if ((lower_Bound <= numbers[i]) && (numbers[i] < upper_Bound))
            {
                bins[j]++;
                found = true;
            }
        }
        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }

    double max_count = bins[0];
    for (size_t j=0; j < bin_count; j++){
        if (bins[j] > max_count) {
            max_count = bins[j];
        }
    }
    vector<size_t> height(bin_count);
    for (size_t j=0; j < bin_count; j++){
        height[j] = MAX_ELEMENT * (bins[j]/max_count);
    }

    if (max_count > MAX_ELEMENT){
        for  (size_t j=0; j < bin_count; j++)
            {
                if (bins[j] < 100) {
                    cout << " ";
                    if (bins[j] < 10){
                            cout << " ";
                    }
                }
                cout << bins[j] << "|";

                for (size_t i=0; i < height[j]; i++){
                        cout << "*";
                        }
                cout << endl;
            }
    }
    else {
        for  (size_t j=0; j < bin_count; j++)
            {
                if (bins[j] < 100) {
                    cout << " ";
                    if (bins[j] < 10){
                            cout << " ";
                    }
                }
                cout << bins[j] << "|";

                for (size_t i=0; i < bins[j];i++){
                        cout << "*";
                        }
                cout << endl;
            }
    }
}
